## di 4.54.0.1

=== C/Makefile ===
#
#  di makefile - C
#
#  Copyright 2001-2018 Brad Lanam Walnut Creek CA, USA
#  Copyright 2023 Brad Lanam, Pleasant Hill, CA
#

MKC_PREFIX = di
MKC_CONFDIR = mkc_config
MKC_FILES = mkc_files
MKC_OUTPUT = config.h
MKC_ENV = $(MKC_PREFIX).env
MKC_ENV_SHR = $(MKC_PREFIX)-shared.env

MKC_CONF = $(MKC_CONFDIR)/$(MKC_PREFIX).mkc
MKC_ENV_CONF = $(MKC_CONFDIR)/$(MKC_PREFIX)-env.mkc
MKC_ENV_SHR_CONF = $(MKC_CONFDIR)/$(MKC_PREFIX)-env-shared.mkc
MKC_CONF_GETOPTN = $(MKC_CONFDIR)/$(MKC_PREFIX)-getoptn.mkc

# for tests.done
DC = gdc

OBJ_EXT = .o
EXE_EXT =

###
# common programs
#
CAT = cat
CHGRP = chgrp
CHMOD = chmod
CHOWN = chown
CP = cp
LN = ln
MKDIR = mkdir
MV = mv
RM = rm
RPMBUILD = rpmbuild
SED = sed
TEST = test

###
# installation options
#
prefix = /usr/local
PREFIX = $(prefix)
BINDIR = $(PREFIX)/bin
DATADIR = $(PREFIX)/share
MANDIR = $(DATADIR)/man
LOCALEDIR = $(DATADIR)/locale

###
# additional flags/libraries
#
DI_SHARED =
DI_CFLAGS = -DDI_LOCALE_DIR=\\\"$(LOCALEDIR)\\\"

###
# mkconfig variables

MKC_DIR = ../mkconfig
MKCONFIG_TYPE = sh
MKC_REQLIB = di.reqlibs
MKC_ECHO =
#MKC_ECHO = -e

###
# main

# have to get various environment variables set up.

.PHONY: all
all:	all-sh

.PHONY: all-sh
all-sh:	$(MKC_ENV)
	. ./$(MKC_ENV);$(MAKE) -e MKCONFIG_TYPE=sh di-programs

.PHONY: all-perl
all-perl:	$(MKC_ENV)
	. ./$(MKC_ENV);$(MAKE) -e MKCONFIG_TYPE=perl di-programs

# perl interface
.PHONY: perl-sh
perl-sh:	$(MKC_ENV_SHR)
	. ./$(MKC_ENV_SHR);$(MAKE) -e MKCONFIG_TYPE=sh perl-programs

.PHONY: perl-perl
perl-perl:	$(MKC_ENV_SHR)
	. ./$(MKC_ENV_SHR);$(MAKE) -e MKCONFIG_TYPE=perl perl-programs

.PHONY: test
test:		tests.done

###
# environment

$(MKC_ENV):	$(MKC_ENV_CONF) ../dioptions.dat
	@-$(RM) -f $(MKC_ENV) tests.done
	CC=$(CC) $(_MKCONFIG_SHELL) $(MKC_DIR)/mkconfig.sh $(MKC_ENV_CONF)

$(MKC_ENV_SHR):	$(MKC_ENV_SHR_CONF)
	@-$(RM) -f $(MKC_ENV_SHR) tests.done
	CC=$(CC) $(_MKCONFIG_SHELL) $(MKC_DIR)/mkconfig.sh \
		$(MKC_ENV_SHR_CONF)

###
# specific builds

# This was tested using vc
# Use:
#     nmake MAKE=nmake windows
#
.PHONY: windows
windows:
	@$(MAKE) ../dioptions.dat
	copy /y NUL: $(MKC_ENV)
	-del config.h
	copy /y /b NUL:+configs\config.ms.cl config.h
	copy /y NUL: $(MKC_REQLIB)
	$(MAKE) \
		MAKE=nmake CC=cl LD=cl EXE_EXT=".exe" OBJ_EXT=".obj" \
		DI_CFLAGS="$(DI_CFLAGS) -nologo -O2" \
		LDFLAGS="-nologo -O2" di-programs

# This was tested using cygwin
.PHONY: windows-gcc
windows-gcc:
	@$(MAKE) ../dioptions.dat
	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
	@-$(RM) -f config.h mkconfig.cache mkc*.vars tests.done
	$(CP) -f configs/config.cygwin.gcc config.h
	@echo '-lintl' > $(MKC_REQLIB)
	$(MAKE) \
		CC=gcc LD=gcc EXE_EXT=".exe" OBJ_EXT=".o" \
		DI_CFLAGS="$(DI_CFLAGS) -g -O2" \
		LDFLAGS="-g -O2" di-programs

.PHONY: windows-msys
windows-msys:
	MAKE=mingw32-make
	cp ../features/dioptions.dat ../dioptions.dat
	> $(MKC_ENV)
	-rm config.h
	cp configs/config.mingw config.h
	> $(MKC_REQLIB)
	$(MAKE) \
		MAKE=$(MAKE) \
		CC=gcc \
		EXE_EXT=".exe" OBJ_EXT=".o" \
		DI_CFLAGS="$(DI_CFLAGS) -g -O2" \
		LDFLAGS="-g -O2" di-programs

.PHONY: windows-mingw
windows-mingw:
	MAKE=mingw32-make
	copy /y /b NUL:+..\features\dioptions.dat ..\dioptions.dat
	copy /y NUL: $(MKC_ENV)
	-del config.h
	copy /y /b NUL:+configs\config.mingw config.h
	copy /y NUL: $(MKC_REQLIB)
	$(MAKE) \
		MAKE=$(MAKE) \
		CC=gcc LD=gcc \
		EXE_EXT=".exe" OBJ_EXT=".o" \
		DI_CFLAGS="$(DI_CFLAGS) -g -O2" \
		LDFLAGS="-g -O2" mingw-di.exe

.PHONY: os2-gcc
os2-gcc:
	@echo ':' > $(MKC_ENV);chmod a+rx $(MKC_ENV)
	$(MAKE) MKCONFIG_TYPE=perl \
		CC=gcc LD=gcc EXE_EXT=".exe" OBJ_EXT=".o" \
		DI_CFLAGS="$(DI_CFLAGS) -g -O2" \
		LDFLAGS="-g -O2 -Zexe" di.exe

###
# cleaning

# leaves:
#   config.h di.reqlibs
#   ../dioptions.dat, tests.done, test_di, $(MKC_ENV), $(MKC_ENV_SHR)
.PHONY: clean
clean:
	@-cd Perl; \
		if [ -f Makefile ]; then \
		$(MAKE) clean; \
		fi
	@-$(RM) -rf di mi \
		di.exe mingw-di.exe mi.exe \
		diskspace.so diskspace.dylib diskspace.dll \
		perlfilesysdi.bld libdiperl.a \
		*.o *.obj $(MKC_FILES)/mkconfig.log \
		tests.done $(MKC_FILES)/_tmp_mkconfig tests.d/chksh* \
		$(MKC_FILES)/mkconfig.cache mkc*.vars \
		getoptn_test* gconfig.h getoptn.reqlibs \
		$(MKC_FILES)/mkconfig.reqlibs $(MKC_FILES)/mkc_compile.log \
		Perl/Filesys-di-*.tar.gz \
		Perl/Makefile.old \
		tests.d/test_order.tmp >/dev/null 2>&1; exit 0
	@-find . -name '*~' -print | xargs rm > /dev/null 2>&1; exit 0

# leaves:
#   _mkconfig_runtests, mkc_files, ../dioptions.dat
#   tests.done, test_di
.PHONY: realclean
realclean:
	@$(MAKE) clean >/dev/null 2>&1
	@-$(RM) -rf config.h gconfig.h \
		$(MKC_ENV) $(MKC_ENV_SHR) $(MKC_REQLIB) \
		>/dev/null 2>&1; exit 0

# leaves:
#   ../dioptions.dat
.PHONY: distclean
distclean:
	@-cd Perl; \
		if [ -f Makefile ]; then \
		$(MAKE) distclean; \
		fi
	@$(MAKE) realclean >/dev/null 2>&1
	@-$(RM) -rf tests.done test_di \
		_mkconfig_runtests \
		$(MKC_FILES) \
		*~ *.orig */*.orig \
		>/dev/null 2>&1; exit 0

###
# installation

.PHONY: install
install:
	$(MAKE) all
	. ./$(MKC_ENV);cd ..;$(MAKE) -e PREFIX=$(PREFIX) \
		LOCALEDIR=$(LOCALEDIR) FROMDIR=C install

###
# programs

.PHONY: di-programs
di-programs:	di$(EXE_EXT)
.PHONY: perl-programs
perl-programs:	perlfilesysdi.bld

###
# configuration file

../dioptions.dat:	../features/dioptions.dat
	cd ../;$(MAKE) dioptions.dat

config.h:	$(MKC_ENV) ../dioptions.dat $(MKC_CONF)
	@-$(RM) -f config.h tests.done
	@if [ "$(DI_NO_NLS)" != "" ]; then \
		echo "*** User requested no NLS"; \
		$(MKC_DIR)/mkc.sh -setopt -o ../dioptions.dat NLS F; fi
	@if [ "$(MKCONFIG_TYPE)" = "sh" -o "$(MKCONFIG_TYPE)" = "" ]; then \
		. ./$(MKC_ENV);$(_MKCONFIG_SHELL) \
		$(MKC_DIR)/mkconfig.sh \
		$(MKC_CONF); fi
	@if [ "$(MKCONFIG_TYPE)" = "perl" ]; then \
		. ./$(MKC_ENV);perl \
		$(MKC_DIR)/mkconfig.pl \
		$(MKC_CONF); fi

$(MKC_REQLIB):	config.h
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
		-o $(MKC_REQLIB) config.h

###
# executables

LIBOBJECTS = dimain$(OBJ_EXT) didiskutil$(OBJ_EXT) \
		digetentries$(OBJ_EXT) digetinfo$(OBJ_EXT) \
		diquota$(OBJ_EXT)  display$(OBJ_EXT) getoptn$(OBJ_EXT) \
		options$(OBJ_EXT) realloc$(OBJ_EXT) strdup$(OBJ_EXT) \
		strstr$(OBJ_EXT) trimchar$(OBJ_EXT)

MAINOBJECTS = di$(OBJ_EXT)

di$(EXE_EXT):	$(MKC_REQLIB) $(MAINOBJECTS) $(LIBOBJECTS)
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
		-link -exec $(MKC_ECHO) \
		-r $(MKC_REQLIB) -o di$(EXE_EXT) \
		$(MAINOBJECTS) $(LIBOBJECTS)

# for ms cl
#di$(EXE_EXT):	$(MAINOBJECTS) $(LIBOBJECTS)
#	$(LD) -Fedi$(EXE_EXT) $(MAINOBJECTS) $(LIBOBJECTS)

perlfilesysdi.bld:	$(MKC_REQLIB) $(LIBOBJECTS)
	@echo "*** Using libs: `$(CAT) $(MKC_REQLIB)`"
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -staticlib $(MKC_ECHO) \
		-o libdiperl.a $(LIBOBJECTS) $(LIBS) \
		`$(CAT) $(MKC_REQLIB)`
	# Don't know how to pass additional libs to Makefile.PL
	# so pass all the information.
	( \
	cd Perl ; \
	perl Makefile.PL LIBS="-L.. -ldiperl `$(CAT) ../$(MKC_REQLIB)`" ; \
	$(MAKE) ; \
	$(MAKE) test ; \
	)
	@touch perlfilesysdi.bld

mingw-di$(EXE_EXT):	$(MAINOBJECTS) $(LIBOBJECTS)
	$(CC) -o mingw-di$(EXE_EXT) \
		$(DI_CFLAGS) $(LDFLAGS) $(LIBOBJECTS) $(LIBS)

###
# objects

.c$(OBJ_EXT):
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -compile $(MKC_ECHO) \
		$(DI_SHARED) $(DI_CFLAGS) $<

# for ms cl
#.c$(OBJ_EXT):
#	$(CC) -c $(DI_SHARED) $(DI_CFLAGS) $<

di$(OBJ_EXT):		di.c config.h di.h dimain.h getoptn.h \
				options.h version.h

dimain$(OBJ_EXT):	dimain.c config.h di.h dimain.h getoptn.h \
				options.h

digetinfo$(OBJ_EXT):	digetinfo.c config.h di.h dimntopt.h

didiskutil$(OBJ_EXT):	didiskutil.c config.h di.h dimntopt.h

digetentries$(OBJ_EXT):	digetentries.c config.h di.h dimntopt.h

diquota$(OBJ_EXT):	diquota.c config.h di.h

display$(OBJ_EXT):	display.c config.h di.h display.h options.h version.h

getoptn$(OBJ_EXT):	getoptn.c config.h getoptn.h

options$(OBJ_EXT):	options.c config.h di.h options.h

realloc$(OBJ_EXT):	realloc.c config.h di.h

strdup$(OBJ_EXT):	strdup.c config.h di.h

strstr$(OBJ_EXT):	strstr.c config.h di.h

trimchar$(OBJ_EXT):	trimchar.c config.h di.h

###
# regression testing

.PHONY: all-test
all-test:	tests.done

tests.done: $(MKC_DIR)/runtests.sh
	@echo "## running tests"
	CC=$(CC) DC=$(DC) $(_MKCONFIG_SHELL) \
		$(MKC_DIR)/runtests.sh ./tests.d
	touch tests.done

# needs environment
.PHONY: testrpmbuild
testrpmbuild:
	-$(TEST) -d ./rpmbuild && rm -rf ./rpmbuild
	$(MKDIR) -p ./rpmbuild/SOURCES
	$(MKDIR) -p ./rpmbuild/BUILD
	$(CP) -f $(DI_DIR)/di-$(DI_VERSION).tar.gz ./rpmbuild/SOURCES
	$(LN) -f ./rpmbuild/SOURCES/di-$(DI_VERSION).tar.gz ./rpmbuild/SOURCES/download
	$(RPMBUILD) --define="_topdir `pwd`/rpmbuild" -ba ../di.spec
	$(TEST) -f ./rpmbuild/RPMS/$(MARCH)/di-$(DI_VERSION)-1.$(MARCH).rpm || exit 1
	$(TEST) -f ./rpmbuild/SRPMS/di-$(DI_VERSION)-1.src.rpm || exit 1
	$(TEST) -d ./rpmbuild && rm -rf ./rpmbuild

# needs environment
.PHONY: rtest-env
rtest-env:
	@echo "$(_MKCONFIG_SYSTYPE)"
	@echo "$(_MKCONFIG_SYSREV)"
	@echo "$(_MKCONFIG_SYSARCH)"
	@echo "$(CC)"
	@echo "$(_MKCONFIG_USING_GCC)"
	@echo "$(CFLAGS_OPTIMIZE)"
	@echo "$(CFLAGS_COMPILER)"
	@echo "$(LDFLAGS_COMPILER)"
	@echo "$(OBJ_EXT)"
	@echo "$(EXE_EXT)"
	@echo "$(XMSGFMT)"

.PHONY: test-env
test-env:
	@echo "cc: $(CC)"
	@echo "make: $(MAKE)"

gconfig.h:	$(MKC_ENV) mkc_config/di-getoptn.mkc
	@-$(RM) -f gconfig.h
	@if [ "$(MKCONFIG_TYPE)" = "sh" -o "$(MKCONFIG_TYPE)" = "" ]; then \
		. ./$(MKC_ENV); \
		$(_MKCONFIG_SHELL) $(MKC_DIR)/mkconfig.sh \
		$(MKC_CONF_GETOPTN); fi
	@if [ "$(MKCONFIG_TYPE)" = "perl" ]; then \
		. ./$(MKC_ENV); \
		perl $(MKC_DIR)/mkconfig.pl \
		$(MKC_CONF_GETOPTN); fi

getoptn_test$(OBJ_EXT):	getoptn.c gconfig.h getoptn.h
	@. ./$(MKC_ENV);$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -compile \
		-DTEST_GETOPTN=1 \
		-o getoptn_test$(OBJ_EXT) getoptn.c

getoptn.reqlibs:	$(MKC_ENV) gconfig.h
	@. ./$(MKC_ENV);$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
		-o getoptn.reqlibs gconfig.h

getoptn_test.exe:	getoptn_test$(OBJ_EXT) getoptn.reqlibs
	@. ./$(MKC_ENV);$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -link -exec \
		$(MKC_ECHO) -r getoptn.reqlibs \
		-o getoptn_test.exe $(LDFLAGS) \
		getoptn_test$(OBJ_EXT)

=== debian/changelog ===
di (4.54.0.1-1) unstable; urgency=medium

  * New upstream version 4.54.0.1

 -- Michael Ablassmeier <abi@debian.org>  Tue, 15 Oct 2024 12:41:26 +0200

di (4.54-1) unstable; urgency=medium

  * New upstream version 4.54
  * Bump standards version

 -- Michael Ablassmeier <abi@debian.org>  Mon, 14 Oct 2024 21:23:33 +0200

=== debian/control ===
Source: di
Section: utils
Priority: optional
Maintainer: Michael Ablassmeier <abi@debian.org>
Build-Depends: debhelper (>= 13), debhelper-compat (=13), gettext
Standards-Version: 4.7.0
Homepage: https://diskinfo-di.sourceforge.io/
Vcs-Git: https://salsa.debian.org/debian/di.git
Vcs-Browser: https://salsa.debian.org/debian/di
Rules-Requires-Root: no

Package: di
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: advanced df like disk information utility
 `di' is a disk information utility, displaying everything
 (and more) that your `df' command does. It features the
 ability to display your disk usage in whatever format you
 desire/prefer/are used to. It is designed to be portable
 across many platforms.

## di 5.0.6

=== CMakeLists.txt ===
#
# Copyright 2025 Brad Lanam Pleasant Hill CA
#
cmake_minimum_required (VERSION 3.13)

# avoid msys2/windows issue
set (CMAKE_C_COMPILER_WORKS 1)

###
# load the DI_* variables from VERSION.txt

file (STRINGS VERSION.txt tdivars)
foreach (tvar IN LISTS tdivars)
  # the export lines are not needed
  if (tvar MATCHES "=")
    string (REGEX MATCH "^[^=]*" tnm ${tvar})
    string (REGEX MATCH "=.*" tvala ${tvar})
    string (REPLACE "=" "" tval ${tvala})
    set (${tnm} ${tval})
  endif()
endforeach()

###
# also set DI_USE_MATH from the environment if there
if (DEFINED ENV{DI_USE_MATH})
  set (DI_USE_MATH $ENV{DI_USE_MATH})
  # these are the only supported values as of 2025-2-6
  if (NOT DI_USE_MATH STREQUAL "DI_INTERNAL" AND
      NOT DI_USE_MATH STREQUAL "DI_GMP" AND
      NOT DI_USE_MATH STREQUAL "DI_TOMMATH")
    unset (DI_USE_MATH)
  endif()
endif()

if (NOT DEFINED DI_BUILD_SYS OR DI_BUILD_SYS STREQUAL "")
  set (DI_BUILD_SYS cmake)
endif()

###
# check to make sure cmake-install-prefix is set
if (NOT DEFINED CMAKE_INSTALL_PREFIX OR CMAKE_INSTALL_PREFIX STREQUAL "")
  message (FATAL_ERROR "CMAKE_INSTALL_PREFIX is not set")
endif()

project (DI
  VERSION ${DI_VERSION}
  DESCRIPTION "di - disk information utility"
  HOMEPAGE_URL "https://diskinfo-di.sourceforge.io"
  LANGUAGES C
)
option (BUILD_SHARED_LIBS "Build dynamic library" ON)

set (default_build_type "Release")

include (GNUInstallDirs)

set (DI_LIBNAME libdi)

SET (CMAKE_SKIP_BUILD_RPATH FALSE)
SET (CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)

if (DEFINED ENV{CMAKE_SKIP_RPATH} AND NOT ENV{CMAKE_SKIP_RPATH} STREQUAL "")
  set (CMAKE_SKIP_RPATH "$ENV{CMAKE_SKIP_RPATH}")
endif()

include (CheckCCompilerFlag)
include (CheckLinkerFlag)
include (CheckIncludeFile)
include (CheckIncludeFiles)
include (CheckLibraryExists)
include (CheckLinkerFlag)
include (CheckStructHasMember)
include (CheckSymbolExists)
include (CheckTypeSize)
include (CheckVariableExists)
include (CheckPrototypeDefinition)

# MacOS cmake uses a path for the compiler that doesn't
# have the proper include paths built in.
# /Library/Developer/CommandLineTools/usr/bin/cc
# I consider this a bug.
# I don't know what the path for the xcode compiler is, but it
# probably starts with /Library/Developer
# this is only used for getting the xdc member types, so
# it doesn't matter much which compiler, just need one that works.
set (MYCC ${CMAKE_C_COMPILER})
if (APPLE AND ${CMAKE_C_COMPILER} MATCHES "^/Library/Developer/")
  set (MYCC /usr/bin/clang)
endif()

#### compile options

macro (checkAddCompileFlag flag)
  # cmake caches every damned variable...
  # need a different variable for every test.
  check_c_compiler_flag (${flag} cfchk${flag})
  if (cfchk${flag})
    add_compile_options (${flag})
  endif()
endmacro()

macro (checkAddLinkFlag flag)
  check_linker_flag ("C" ${flag} lfchk${flag})
  if (lfchk${flag})
    add_link_options (${flag})
  endif()
endmacro()

checkAddCompileFlag ("-fPIC")
checkAddLinkFlag ("-fPIC")

checkAddCompileFlag ("-Wall")
checkAddCompileFlag ("-Wextra")
checkAddCompileFlag ("-Wconversion")
checkAddCompileFlag ("-Wno-unused-but-set-variable")
checkAddCompileFlag ("-Wno-unused-parameter")
checkAddCompileFlag ("-Wno-unknown-pragmas")
checkAddCompileFlag ("-Wno-float-equal")
checkAddCompileFlag ("-Wformat")
checkAddCompileFlag ("-Wformat-security")
checkAddCompileFlag ("-Werror=format-security")
checkAddCompileFlag ("-Werror=return-type")
checkAddCompileFlag ("-Wdeprecated-declarations")
checkAddCompileFlag ("-Wunreachable-code")

# these don't work w/c++
checkAddCompileFlag ("-Wdeclaration-after-statement")
checkAddCompileFlag ("-Wmissing-prototypes")

#### compiler-specific compile options

checkAddCompileFlag ("-Wmaybe-uninitialized")
checkAddCompileFlag ("-Wno-unused-but-set-variable")
checkAddCompileFlag ("-Wno-stringop-overflow")
checkAddCompileFlag ("-Wno-stringop-truncation")
checkAddCompileFlag ("-Wno-format-truncation")
checkAddCompileFlag ("-Wno-extra-semi-stmt")
checkAddCompileFlag ("-Wno-poison-system-directories")
checkAddCompileFlag ("-Wno-shift-sign-overflow")
checkAddCompileFlag ("-Wno-pragma-pack")
checkAddCompileFlag ("-Wno-ignored-attributes")
checkAddCompileFlag ("-Wno-reserved-macro-identifier")
checkAddCompileFlag ("-Wno-reserved-id-macro")
checkAddCompileFlag ("-Wno-implicit-int-conversion")
checkAddCompileFlag ("-Wno-switch-enum")
checkAddCompileFlag ("-Wno-gnu-zero-variadic-macro-arguments")
checkAddCompileFlag ("-Wno-documentation-deprecated-sync")
checkAddCompileFlag ("-Wno-documentation-unknown-command")
checkAddCompileFlag ("-Wno-documentation")
checkAddCompileFlag ("-Wno-unsafe-buffer-usage")
# llvm-19 creating errors about *printf
checkAddCompileFlag ("-Wno-used-but-marked-unused")

###
# LFS_CFLAGS, LFS_LDFLAGS, LFS_LIBS

macro (applygetconfflags which)
  execute_process (
    OUTPUT_VARIABLE lfs${which}
    ERROR_QUIET
    COMMAND getconf LFS_${which}
    COMMAND tr -d "\n"
  )
  separate_arguments (lfsl${which} UNIX_COMMAND ${lfs${which}})
  if (DEFINED lfs${which} AND NOT lfs${which} STREQUAL "")
    message ("-- getconf: ${which}: ${lfs${which}}")
    foreach (tvar IN LISTS lfsl${which})
      if (${which} STREQUAL "CFLAGS")
        add_compile_options (${tvar})
      endif()
      if (${which} STREQUAL "LDFLAGS")
        add_link_options (${tvar})
      endif()
      if (${which} STREQUAL "LIBS")
        # extremely rare, if ever
        link_libraries (${tvar})
      endif()
    endforeach()
  endif()
endmacro()

message ("-- Getting LFS flags via getconf")
applygetconfflags ("CFLAGS")
applygetconfflags ("LDFLAGS")
applygetconfflags ("LIBS")

#### build compile options

if (NOT DEFINED DI_BUILD OR DI_BUILD STREQUAL "")
  set (DI_BUILD "Release")
endif()

if (DI_BUILD STREQUAL "Release")
  add_compile_options (-O2)
endif()

if (DI_BUILD STREQUAL "Debug")
  add_compile_options (-O0)
endif()

add_compile_options (-g)
add_link_options (-g)

#### more compile options: fortification/address sanitizer

set (DI_FORTIFY Y)
if (DEFINED ENV{DI_FORTIFY} AND NOT ENV{DI_FORTIFY} STREQUAL "")
  set (DI_FORTIFY $ENV{DI_FORTIFY})
endif()

# address sanitizer
if (DI_BUILD STREQUAL "SanitizeAddress")
  set (DI_FORTIFY N)
  add_compile_options (-O0)
  checkAddCompileFlag ("-ggdb")
  add_link_options (-g)
  checkAddCompileFlag ("-fsanitize=address")
  checkAddLinkFlag ("-fsanitize=address")
  checkAddCompileFlag ("-fsanitize-address-use-after-scope")
  checkAddLinkFlag ("-fsanitize-address-use-after-scope")
  checkAddCompileFlag ("-fsanitize-recover=address")
  checkAddLinkFlag ("-fsanitize-recover=address")
  checkAddCompileFlag ("-fno-omit-frame-pointer")
  checkAddCompileFlag ("-fno-common")
  checkAddCompileFlag ("-fno-inline")
  if (CMAKE_C_COMPILER_ID STREQUAL "GNU")
    # the gnu C compiler needs this library for the sanitizer
    # other compilers should not link it in.
    checkAddLinkFlag ("-lrt")
  endif()
endif()

# on solaris, the flags are accepted, but the link fails.
if (DI_FORTIFY STREQUAL Y AND NOT CMAKE_HOST_SOLARIS)
  # hardening
  checkAddCompileFlag ("-fstack-protector-strong")
  checkAddCompileFlag ("-fstack-protector-all")
  add_compile_options ("-D_FORTIFY_SOURCE=2")
else()
  checkAddCompileFlag ("-Wno-macro-redefined")
  add_compile_options ("-U_FORTIFY_SOURCE")
  add_compile_options ("-D_FORTIFY_SOURCE=0")
endif()

#### system specific compile options

if (NOT WIN32)
  SET (CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR})
  if (NOT APPLE)
#    SET (CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR} "\${ORIGIN}")
  endif()
  if (APPLE)
#    SET (CMAKE_INSTALL_RPATH ${CMAKE_INSTALL_FULL_LIBDIR} "@loader_path")
    # 10.6 = Snow Leopard, 10.7 = Lion
    # 10.8 = Mountain Lion, 10.9 = Mavericks
    # 10.10 = Yosemite, 10.11 = El Capitan
    # 10.12 = Sierra, 10.13 = High Sierra
    # 10.14 = Mojave, 10.15 = Catalina
    # 11 = Big Sur, 12 = Monterey,
    # 13 = Ventura, 14 = Sonoma
    # 15 = Sequoia
    # set (CMAKE_OSX_ARCHITECTURES "arm64;x86_64")
  endif()
else()
  add_link_options (-static-libgcc)
  add_link_options (-static-libstdc++)
endif()

#### include paths

include_directories (
  SYSTEM
  # for macos
  /opt/local/include
  # for freebsd
  /usr/local/include
  "${CMAKE_BINARY_DIR}"
  "${PROJECT_SOURCE_DIR}/include"
)

set (required_includes
  # for macos
  /opt/local/include
  # for freebsd
  /usr/local/include
)

set (CMAKE_REQUIRED_INCLUDES ${required_includes})
add_compile_options (-DWIN32_LEAN_AND_MEAN=1)

#### configuration

find_package (PkgConfig)
find_package (Intl)
find_package (Iconv)

pkg_check_modules (GMP gmp)
pkg_check_modules (TOMMATH libtommath)
pkg_check_modules (TIRPC libtirpc)

###
# macros for capability testing

macro (checkPrototype_quotactl hdr)
  # this fails when using the c++ compiler.
  # the c++ compiler is only needed on Haiku,
  # but it would be nice to be able to test it elsewhere
  # the mkconfig suite can be used to test c++.
  check_prototype_definition (quotactl
    "int quotactl (const char * a, int b, int c, void * d)"
    0
    "${hdr}"
    _quotactl_pos_1a
    )
  # OpenBSD has char *, but caddr_t works...
  #  "int quotactl (const char *path, int cmd, int id, char *addr)"
  check_prototype_definition (quotactl
    "int quotactl (const char * a, int b, int c, caddr_t d)"
    0
    "${hdr}"
    _quotactl_pos_1b
    )
  check_prototype_definition (quotactl
    "int quotactl (int a, const char * b, int c, caddr_t d)"
    0
    "${hdr}"
    _quotactl_pos_2a
    )
  # alpine linux
  check_prototype_definition (quotactl
    "int quotactl (int a, const char * b, int c, char *d)"
    0
    "${hdr}"
    _quotactl_pos_2b
    )
  if (_quotactl_pos_1a OR _quotactl_pos_1b)
    set (_quotactl_pos_1 1)
  endif()
  if (_quotactl_pos_2a OR _quotactl_pos_2b)
    set (_quotactl_pos_2 1)
  endif()
  if (_quotactl_pos_1)
    set (_c_arg_2_quotactl "int")
    set (_args_quotactl 4)
  endif()
  if (_quotactl_pos_2)
    set (_c_arg_2_quotactl "const char *")
    set (_args_quotactl 4)
  endif()
endmacro()

macro (checkPrototype_statfs hdr)
  check_prototype_definition (statfs
    "int statfs (const char * a, struct statfs * b)"
    0
    "${hdr}"
    _args_statfs_2
    )
  check_prototype_definition (statfs
    "int statfs (const char * a, struct statfs * b, int c)"
    0
    "${hdr}"
    _args_statfs_3
    )
  check_prototype_definition (statfs
    "int statfs (const char * a, struct statfs * b, int c, int d)"
    0
    "${hdr}"
    _args_statfs_4
    )
  if (_args_statfs_2)
    set (_args_statfs 2)
  endif()
  if (_args_statfs_3)
    set (_args_statfs 3)
  endif()
  if (_args_statfs_4)
    set (_args_statfs 4)
  endif()
endmacro()

macro (checkMember_statfs hdr)
  check_struct_has_member ("struct statfs" f_bsize
      "${hdr}" _mem_struct_statfs_f_bsize)
  check_struct_has_member ("struct statfs" f_fsize
      "${hdr}" _mem_struct_statfs_f_fsize)
  check_struct_has_member ("struct statfs" f_fstyp
      "${hdr}" _mem_struct_statfs_f_fstyp)
  check_struct_has_member ("struct statfs" f_iosize
      "${hdr}" _mem_struct_statfs_f_iosize)
  check_struct_has_member ("struct statfs" f_frsize
      "${hdr}" _mem_struct_statfs_f_frsize)
  check_struct_has_member ("struct statfs" f_fstypename
      "${hdr}" _mem_struct_statfs_f_fstypename)
  check_struct_has_member ("struct statfs" mount_info
      "${hdr}" _mem_struct_statfs_mount_info)
  check_struct_has_member ("struct statfs" f_type
      "${hdr}" _mem_struct_statfs_f_type)
endmacro()

macro (checkPrototype_setmntent hdr)
  check_prototype_definition (setmntent
    "FILE * setmntent (const char * a)"
    "NULL"
    "stdio.h;stddef.h;${hdr}"
    _args_setmntent_1
    )
  check_prototype_definition (setmntent
    "FILE * setmntent (const char * a, const char * b)"
    "NULL"
    "stdio.h;stddef.h;${hdr}"
    _args_setmntent_2
    )
  if (_args_setmntent_1)
    set (_args_setmntent 1)
  endif()
  if (_args_setmntent_2)
    set (_args_setmntent 2)
  endif()
endmacro()

macro (checkPrototype_getfsstat hdr)

=== Makefile ===
#
#  di makefile - C
#
#  Copyright 2001-2018 Brad Lanam Walnut Creek CA, USA
#  Copyright 2023-2025 Brad Lanam, Pleasant Hill, CA
#

# for checking cmake
CMAKE_REQ_MAJ_VERSION = 3
CMAKE_REQ_MIN_VERSION = 13
BUILDDIR = build
DI_BUILD = Release

# DI_USE_MATH = DI_GMP
# DI_USE_MATH = DI_TOMMATH
# DI_USE_MATH = DI_INTERNAL

# for mkconfig
MKC_CONFDIR = mkc_config
MKC_FILES = mkc_files
MKC_ENV = di.env
MKC_CONF = $(MKC_CONFDIR)/di.mkc
MKC_ENV_CONF = $(MKC_CONFDIR)/di-env.mkc
#
#    To turn off stack fortification:
#
#      make -e DI_FORTIFY=N PREFIX=$HOME/local
#      make -e DI_FORTIFY=N PREFIX=$HOME/local install
#
DI_FORTIFY = Y

OBJ_EXT = .o
EXE_EXT =

###
# installation locations
#  the cmake install only uses PREFIX
#
PREFIX =
BINDIR = $(PREFIX)/bin
LIBNM = lib
LIBDIR = $(PREFIX)/$(LIBNM)
INCDIR = $(PREFIX)/include
PKGCDIR = $(LIBDIR)/pkgconfig
SHAREDIR = $(PREFIX)/share
MANDIR = $(SHAREDIR)/man
LOCALEDIR = $(SHAREDIR)/locale

INST_DIR = $(DESTDIR)$(PREFIX)
INST_INCDIR = $(DESTDIR)$(INCDIR)
INST_BINDIR = $(DESTDIR)$(BINDIR)
INST_LIBDIR = $(DESTDIR)$(LIBDIR)
INST_SHAREDIR = $(DESTDIR)$(SHAREDIR)
INST_PKGCDIR = $(DESTDIR)$(PKGCDIR)
INST_MANDIR = $(DESTDIR)$(MANDIR)
INST_LOCALEDIR = $(DESTDIR)$(LOCALEDIR)

###
# mkconfig variables

MKC_DIR = mkconfig
MKCONFIG_TYPE = sh
MKC_REQLIB = di.reqlibs
MKC_ECHO =
#MKC_ECHO = -e

###
# generic targets

.PHONY: all
all:
	@$(MAKE) -e TARGET=$@ switcher

.PHONY: install
install:
	@$(MAKE) -e TARGET=$@ switcher

.PHONY: test
test:
	@$(MAKE) -e TARGET=$@ switcher

.PHONY: chkswitcher
chkswitcher:
	@$(MAKE) -e TARGET=$@ switcher

# checks the cmake version, and builds using either cmake or mkconfig
.PHONY: switcher
switcher:
	@if [ "$(PREFIX)" = "" ]; then echo "No prefix set"; exit 1; fi
	@bldval=`./utils/chkcmake.sh \
	    $(CMAKE_REQ_MAJ_VERSION) $(CMAKE_REQ_MIN_VERSION)` ; \
	if [ $$bldval = cmake ]; then \
	  $(MAKE) -e cmake-$(TARGET) ; \
	else \
	  $(MAKE) -e mkc-$(TARGET) ; \
	fi

###
# cleaning

# clean temporary files
.PHONY: tclean
tclean:
	@-rm -f w ww asan.* *.orig \
		dep-*.txt >/dev/null 2>&1; exit 0
	@-find . -name '*~' -print0 | xargs -0 rm > /dev/null 2>&1; exit 0
	@-find . -name '*.orig' -print0 | xargs -0 rm > /dev/null 2>&1; exit 0

# leaves config.h
.PHONY: clean
clean:
	@$(MAKE) tclean
	@-rm -f \
		di libdi.* dimathtest getoptn_test \
		di.exe libdi.dll dimathtest.exe getoptn_test.exe \
		*.o *.obj \
		$(MKC_FILES)/mkc_compile.log \
		tests.d/chksh* \
		tests.d/test_order.tmp >/dev/null 2>&1; exit 0
	@-test -d $(BUILDDIR) && cmake --build $(BUILDDIR) --target clean

.PHONY: realclean
realclean:
	@$(MAKE) clean >/dev/null 2>&1
	@-rm -rf config.h \
		$(MKC_ENV) $(MKC_REQLIB) \
		_mkconfig_runtests \
		>/dev/null 2>&1; exit 0

.PHONY: distclean
distclean:
	@$(MAKE) realclean >/dev/null 2>&1
	@-rm -rf test_di _mkconfig_runtests \
		test_results x \
		$(MKC_FILES) \
		$(BUILDDIR) \
		>/dev/null 2>&1; exit 0

###
# utility

.PHONY: tar
tar:
	./utils/mktar.sh

###
# cmake

.PHONY: cmake-debug
cmake-debug:
	$(MAKE) -e DI_BUILD=Debug cmake-all

.PHONY: cmake-sanitize
cmake-sanitize:
	$(MAKE) -e DI_BUILD=SanitizeAddress cmake-all

# parallel doesn't seem to work under msys2
# cmake doesn't seem to support parallel under *BSD
#   (passing -j w/o arguments, and *BSD complains)
.PHONY: cmake-all
cmake-all:
	@case $$(uname -s) in \
	  CYGWIN*) \
	    COMP=$(CC) \
	    $(MAKE) -e cmake-unix; \
	    $(MAKE) -e cmake-build; \
	    ;; \
	  MSYS*|MINGW*) \
	    COMP=$(CC) \
	    $(MAKE) -e cmake-windows; \
	    $(MAKE) -e cmake-build; \
	    ;; \
	  *BSD*) \
	    COMP=$(CC) \
	    $(MAKE) -e cmake-unix; \
	    $(MAKE) -e cmake-build; \
	    ;; \
	  *) \
	    COMP=$(CC) \
	    $(MAKE) -e cmake-unix; \
	    pmode=--parallel $(MAKE) -e cmake-build; \
	    ;; \
	esac

.PHONY: cmakeclang
cmakeclang:
	case $$(uname -s) in \
	  *BSD*) \
	    COMP=$(CC) \
	    $(MAKE) -e cmake-unix; \
	    $(MAKE) -e cmake-build; \
	    ;; \
	  MSYS*|MINGW*) \
	    COMP=/ucrt64/bin/clang.exe \
	    $(MAKE) -e cmake-windows; \
	    $(MAKE) -e cmake-build; \
	    ;; \
	  *) \
	    $(MAKE) -e cmake-unix; \
	    pmode=--parallel $(MAKE) -e cmake-build; \
	    ;; \
	esac

# --debug-trycompile
# internal use
.PHONY: cmake-unix
cmake-unix:
	@if [ "$(PREFIX)" = "" ]; then echo "No prefix set"; exit 1; fi
	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
	cmake \
		-DCMAKE_C_COMPILER=$(COMP) \
		-DCMAKE_INSTALL_PREFIX="$(PREFIX)" \
		-DDI_BUILD:STATIC=$(DI_BUILD) \
		-DDI_BUILD_SYS:STATIC=make-cmake \
		-S . -B $(BUILDDIR) -Werror=deprecated

# internal use
.PHONY: cmake-windows
cmake-windows:
	@if [ "$(PREFIX)" = "" ]; then echo "No prefix set"; exit 1; fi
	@test -d $(BUILDDIR) || mkdir $(BUILDDIR)
	cmake \
		-DCMAKE_C_COMPILER=$(COMP) \
		-DCMAKE_INSTALL_PREFIX="$(PREFIX)" \
		-DDI_BUILD:STATIC=$(DI_BUILD) \
		-DDI_BUILD_SYS:STATIC=make-cmake \
		-G "MSYS Makefiles" \
		-S . -B $(BUILDDIR) -Werror=deprecated

# cmake on windows installs extra unneeded crap
# --parallel does not work correctly on msys2
# --parallel also seems to not work on *BSD
.PHONY: cmake-build
cmake-build:
	cmake --build $(BUILDDIR) $(pmode)

.PHONY: cmake-install
cmake-install:
	cmake --install $(BUILDDIR)

.PHONY: cmake-test
cmake-test:
	./build/dimathtest
	./build/getoptn_test

.PHONY: cmake-chkswitcher
cmake-chkswitcher:
	@echo "cmake"

###
# main

# have to get various environment variables set up.

# don't know any good way to determine if lib64 is preferred
.PHONY: mkc-all
mkc-all:
	@. ./VERSION.txt ; \
	libnm=`./utils/chklibnm.sh` ; \
	$(MAKE) -e LIBNM=$$libnm mkc-sh

.PHONY: mkc-sh
mkc-sh:	$(MKC_ENV)
	. ./$(MKC_ENV);$(MAKE) -e MKCONFIG_TYPE=sh \
		DI_PREFIX=$(PREFIX) \
		mkc-di-programs

.PHONY: mkc-perl
mkc-perl:	$(MKC_ENV)
	. ./$(MKC_ENV) ; \
		DI_PREFIX=$(PREFIX) \
		DI_VERSION=$(DI_VERSION) \
		DI_LIBVERSION=$(DI_LIBVERSION) \
		DI_SOVERSION=$(DI_SOVERSION) \
		DI_RELEASE_STATUS=$(DI_RELEASE_STATUS) \
		$(MAKE) -e MKCONFIG_TYPE=perl \
		mkc-di-programs

.PHONY: mkc-test
mkc-test:
	. ./$(MKC_ENV); \
	    ./dimathtest$(EXE_EXT); \
	    ./getoptn_test$(EXE_EXT)

.PHONY: mkc-chkswitcher
mkc-chkswitcher:
	@echo "mkc"

.PHONY: mkc-install
mkc-install: $(MKC_ENV) mkc-all
	@. ./VERSION.txt ; \
	libnm=`./utils/chklibnm.sh` ; \
	. ./$(MKC_ENV);$(MAKE) -e \
	      PREFIX=$(PREFIX) LIBNM=$$libnm mkc-install-all

###
# installation

.PHONY: mkc-install-all
mkc-install-all:
	$(MAKE) -e mkc-install-di
	$(MAKE) -e mkc-install-include
	$(MAKE) -e mkc-install-libdi
	-$(MAKE) -e mkc-install-po
	$(MAKE) -e mkc-install-man
	$(MAKE) -e mkc-install-pc

.PHONY: mkc-install-po
mkc-install-po:
	test -d $(INST_LOCALEDIR) || mkdir -p $(INST_LOCALEDIR)
	-./utils/instpo.sh $(INST_LOCALEDIR)

.PHONY: mkc-install-pc
mkc-install-pc: $(MKC_REQLIB)
	test -d $(INST_PKGCDIR) || mkdir -p $(INST_PKGCDIR)
	@dilibs="$${LDFLAGS_LIBS_APPLICATION} `cat $(MKC_REQLIB)`" ; \
	dilibs="`echo $${dilibs} | \
	    sed -e 's,-lintl,,g' \
	    -e 's,-liconv,,g'`" ; \
	cat di.pc.in | \
	  sed -e 's,@CMAKE_INSTALL_PREFIX@,$(PREFIX),g' \
	      -e 's,@CMAKE_INSTALL_FULL_INCLUDEDIR@,$(INCDIR),g' \
	      -e 's,@CMAKE_INSTALL_FULL_LIBDIR@,$(LIBDIR),g' \
	      -e 's,@DI_VERSION@,$(DI_VERSION),g' \
	      -e "s~@DI_REQUIRED_LIBS@~$${dilibs}~" \
	  > $(INST_PKGCDIR)/di.pc

.PHONY: mkc-install-di
mkc-install-di:
	test -d $(INST_BINDIR) || mkdir -p $(INST_BINDIR)
	cp -f di$(EXE_EXT) $(INST_BINDIR)

.PHONY: mkc-install-include
mkc-install-include:
	test -d $(INST_INCDIR) || mkdir -p $(INST_INCDIR)
	cp -f di.h $(INST_INCDIR)

# not sure about how the naming works on aix
# OpenBSD only has the main version, no plain .so
.PHONY: mkc-install-libdi
mkc-install-libdi:
	test -d $(INST_LIBDIR) || mkdir -p $(INST_LIBDIR)
	@sym=T ; \
	instdest=$(INST_LIBDIR) ; \
	case `uname -s` in \
	  Darwin) \
	    libnm=libdi.$(DI_LIBVERSION)$(SHLIB_EXT) ; \
	    libnmso=libdi.$(DI_SOVERSION)$(SHLIB_EXT) ; \
	    ;; \
	  CYGWIN*|MSYS*|MINGW*) \
	    instdest=$(INST_BINDIR) ; \
	    libnm=libdi$(SHLIB_EXT) ; \
	    sym=F ; \
	    ;; \
	  OpenBSD) \
	    libnm=libdi$(SHLIB_EXT).$(DI_LIBVERSION) ; \
	    libnmso=libdi$(SHLIB_EXT).$(DI_SOVERSION) ; \
	    sym=O ; \
	    ;; \
	  *) \
	    libnm=libdi$(SHLIB_EXT).$(DI_LIBVERSION) ; \
	    libnmso=libdi$(SHLIB_EXT).$(DI_SOVERSION) ; \
	    ;; \
	esac ; \
	cp -f libdi$(SHLIB_EXT) $${instdest}/$${libnm} ; \
	if [ $$sym = T -o $$sym = O ]; then \
	  ( \
	    cd $(INST_LIBDIR) ; \
	    ln -sf $${libnm} $${libnmso} ; \
	  ) ; \
	fi ; \
	if [ $$sym = T ]; then \
	  ( \
	    cd $(INST_LIBDIR) ; \
	    ln -sf $${libnmso} libdi$(SHLIB_EXT) ; \
	  ) ; \
	fi

.PHONY: mkc-install-man
mkc-install-man:
	-test -d $(INST_MANDIR)/man1 || mkdir -p $(INST_MANDIR)/man1
	cp -f man/di.1 $(INST_MANDIR)/man1/$(MAN_TARGET)
	-test -d $(INST_MANDIR)/man3 || mkdir -p $(INST_MANDIR)/man3
	cp -f man/libdi.3 $(INST_MANDIR)/man3/$(MAN_TARGET)

###
# mkc environment

$(MKC_ENV):	$(MKC_ENV_CONF)
	@-rm -f $(MKC_ENV)
	CC=$(CC) DI_FORTIFY=$(DI_FORTIFY) \
	    $(_MKCONFIG_SHELL) $(MKC_DIR)/mkconfig.sh $(MKC_ENV_CONF)

###
# programs

.PHONY: mkc-di-programs
mkc-di-programs:	di$(EXE_EXT) dimathtest$(EXE_EXT) getoptn_test$(EXE_EXT)

###
# configuration file

config.h:	$(MKC_ENV) $(MKC_CONF)
	@-rm -f config.h
	@if [ "$(MKCONFIG_TYPE)" = "sh" -o "$(MKCONFIG_TYPE)" = "" ]; then \
		. ./$(MKC_ENV);$(_MKCONFIG_SHELL) \
		$(MKC_DIR)/mkconfig.sh \
		$(MKC_CONF); fi
	@if [ "$(MKCONFIG_TYPE)" = "perl" ]; then \
		. ./$(MKC_ENV);perl \
		$(MKC_DIR)/mkconfig.pl \
		$(MKC_CONF); fi

$(MKC_REQLIB):	config.h
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -reqlib \
		-o $(MKC_REQLIB) config.h

###
# executables

LIBOBJECTS = dilib$(OBJ_EXT) didiskutil$(OBJ_EXT) \
		digetentries$(OBJ_EXT) digetinfo$(OBJ_EXT) \
		diquota$(OBJ_EXT) dizone$(OBJ_EXT) getoptn$(OBJ_EXT) \
		dioptions$(OBJ_EXT) distrutils$(OBJ_EXT)

MAINOBJECTS = di$(OBJ_EXT)

libdi$(SHLIB_EXT):	$(MKC_REQLIB) $(LIBOBJECTS)
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
		-link -shared $(MKC_ECHO) \
		-r $(MKC_REQLIB) \
		-o libdi$(SHLIB_EXT) \
		$(LIBOBJECTS)

di$(EXE_EXT):	$(MKC_REQLIB) $(MAINOBJECTS) libdi$(SHLIB_EXT)
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
		-link -exec $(MKC_ECHO) \
		-r $(MKC_REQLIB) \
		-o di$(EXE_EXT) \
		$(MAINOBJECTS) \
		-L . -ldi \
		-R $(LIBDIR)

dimathtest$(EXE_EXT):	dimathtest$(OBJ_EXT)
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
		-link -exec $(MKC_ECHO) \
		-o dimathtest$(EXE_EXT) \
		dimathtest$(OBJ_EXT) \
		-l m

getoptn_test$(EXE_EXT):	getoptn_test$(OBJ_EXT) distrutils$(OBJ_EXT)
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
		-link -exec $(MKC_ECHO) \
		-o getoptn_test$(EXE_EXT) \
		getoptn_test$(OBJ_EXT) \
		distrutils$(OBJ_EXT) \
		-l m

###
# objects

.c$(OBJ_EXT):
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh -compile -shared $(MKC_ECHO) $<

di$(OBJ_EXT):		di.c

didiskutil$(OBJ_EXT):	didiskutil.c

digetentries$(OBJ_EXT):	digetentries.c

digetinfo$(OBJ_EXT):	digetinfo.c

dilib$(OBJ_EXT):	dilib.c

dimathtest$(OBJ_EXT):	dimathtest.c

dioptions$(OBJ_EXT):	dioptions.c

diquota$(OBJ_EXT):	diquota.c

distrutils$(OBJ_EXT):	distrutils.c

dizone$(OBJ_EXT):	dizone.c

getoptn$(OBJ_EXT):	getoptn.c

getoptn_test$(OBJ_EXT):	getoptn.c
	@$(_MKCONFIG_SHELL) $(MKC_DIR)/mkc.sh \
		-compile $(MKC_ECHO) \
		-DTEST_GETOPTN=1 \
		-o getoptn_test$(OBJ_EXT) getoptn.c

# DO NOT DELETE

di.o: config.h
di.o: di.h
di.o: disystem.h distrutils.h
didiskutil.o: config.h
didiskutil.o: di.h disystem.h
didiskutil.o: diinternal.h
didiskutil.o: dimath.h dioptions.h getoptn.h
didiskutil.o: distrutils.h dimntopt.h
digetentries.o: config.h
digetentries.o: di.h disystem.h
digetentries.o: diinternal.h dimath.h
digetentries.o: dioptions.h getoptn.h distrutils.h
digetentries.o: dimntopt.h
digetinfo.o: config.h
digetinfo.o: di.h disystem.h
digetinfo.o: diinternal.h
digetinfo.o: dimath.h dioptions.h getoptn.h
digetinfo.o: dimntopt.h
digetinfo.o: distrutils.h
dilib.o: config.h
dilib.o: di.h disystem.h
dilib.o: dimath.h diinternal.h
dilib.o: dioptions.h getoptn.h dizone.h diquota.h distrutils.h
dimathtest.o: config.h
dimathtest.o: dimath.h

=== debian/changelog ===
di (5.0.6-1) unstable; urgency=medium

  * New upstream version 5.0.6

 -- Michael Ablassmeier <abi@debian.org>  Tue, 11 Feb 2025 09:53:22 +0100

di (5.0.5-1) unstable; urgency=medium

  * New upstream version 5.0.5

 -- Michael Ablassmeier <abi@debian.org>  Mon, 10 Feb 2025 09:53:20 +0100

di (5.0.4-1) unstable; urgency=medium

  * New upstream version 5.0.4
  * Split package into libdi/libdi-dev and executable.

 -- Michael Ablassmeier <abi@debian.org>  Fri, 07 Feb 2025 23:05:50 +0100

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,13 @@
 Section: utils
 Priority: optional
 Maintainer: Michael Ablassmeier <abi@debian.org>
-Build-Depends: debhelper (>= 13), debhelper-compat (=13), gettext
+Build-Depends: debhelper (>= 13),
+               debhelper-compat (=13),
+               cmake,
+               gettext,
+               libtirpc-dev,
+               libtommath-dev,
+               pkgconf
 Standards-Version: 4.7.0
 Homepage: https://diskinfo-di.sourceforge.io/
 Vcs-Git: https://salsa.debian.org/debian/di.git
@@ -18,3 +24,21 @@
  ability to display your disk usage in whatever format you
  desire/prefer/are used to. It is designed to be portable
  across many platforms.
+
+Package: libdi-dev
+Architecture: any
+Depends: libdi5 (= ${binary:Version}), ${misc:Depends}
+Section: libdevel
+Description: Header files for libdi
+ Development files for libdi, a shared library that can be used to get disk
+ space or percentages.
+
+Package: libdi5
+Architecture: any
+Multi-Arch: same
+Pre-Depends: ${misc:Pre-Depends}
+Depends: ${misc:Depends}, ${shlibs:Depends}
+Section: libs
+Description: Common libraries for di
+ The libdi package provides the shared libraries for the advanced
+ disk information utility

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1

%:
	dh $@

override_dh_auto_configure:
	$(MAKE) COMP=$(CC) PREFIX=$(CURDIR)/debian/di/usr/ CMAKE_SKIP_RPATH=TRUE cmake-unix

override_dh_auto_build:
	dh_auto_build -- cmake-build

override_dh_auto_install:

override_dh_auto_test:

override_dh_auto_clean:
	dh_auto_clean
	rm -f dioptions.dat

## di 5.0.12

=== CMakeLists.txt ===
--- 
+++ 
@@ -75,17 +75,22 @@
 include (CheckVariableExists)
 include (CheckPrototypeDefinition)
 
-# MacOS cmake uses a path for the compiler that doesn't
-# have the proper include paths built in.
-# /Library/Developer/CommandLineTools/usr/bin/cc
-# I consider this a bug.
-# I don't know what the path for the xcode compiler is, but it
-# probably starts with /Library/Developer
-# this is only used for getting the xdc member types, so
-# it doesn't matter much which compiler, just need one that works.
-set (MYCC ${CMAKE_C_COMPILER})
-if (APPLE AND ${CMAKE_C_COMPILER} MATCHES "^/Library/Developer/")
-  set (MYCC /usr/bin/clang)
+if (APPLE)
+  # MacOS cmake uses a path for the compiler that doesn't
+  # have the proper include paths built in.  /usr/bin/clang
+  # works with command line tools, but apparently not for xcode.
+  # if the SDKROOT environment variable is not set, set it.
+  if (NOT DEFINED ENV{SDKROOT})
+    execute_process (
+      OUTPUT_VARIABLE sdktemp
+      ERROR_QUIET
+      COMMAND xcrun --sdk macosx --show-sdk-path
+      COMMAND tr -d "\n"
+    )
+    if (DEFINED sdktemp AND NOT sdktemp STREQUAL "")
+      set (ENV{SDKROOT} ${sdktemp})
+    endif()
+  endif()
 endif()
 
 #### compile options
@@ -272,6 +277,7 @@
   SYSTEM
   # for macos
   /opt/local/include
+  /opt/homebrew/include
   # for freebsd
   /usr/local/include
   "${CMAKE_BINARY_DIR}"
@@ -281,6 +287,7 @@
 set (required_includes
   # for macos
   /opt/local/include
+  /opt/homebrew/include
   # for freebsd
   /usr/local/include
 )
@@ -417,6 +424,3 @@
   if (_args_setmntent_2)
     set (_args_setmntent 2)
   endif()
-endmacro()
-
-macro (checkPrototype_getfsstat hdr)

=== Makefile ===
--- 
+++ 
@@ -116,7 +116,7 @@
 		*.o *.obj \
 		$(MKC_FILES)/mkc_compile.log \
 		tests.d/chksh* \
-		tests.d/test_order.tmp >/dev/null 2>&1; exit 0
+		>/dev/null 2>&1; exit 0
 	@-test -d $(BUILDDIR) && cmake --build $(BUILDDIR) --target clean
 
 .PHONY: realclean
@@ -307,8 +307,7 @@
 
 .PHONY: mkc-install-po
 mkc-install-po:
-	test -d $(INST_LOCALEDIR) || mkdir -p $(INST_LOCALEDIR)
-	-./utils/instpo.sh $(INST_LOCALEDIR)
+	-./utils/instpo.sh "`pwd`/po" $(INST_LOCALEDIR) "`pwd`/tmp"
 
 .PHONY: mkc-install-pc
 mkc-install-pc: $(MKC_REQLIB)
@@ -517,3 +516,6 @@
 dilib.o: dioptions.h getoptn.h dizone.h diquota.h distrutils.h
 dimathtest.o: config.h
 dimathtest.o: dimath.h
+dioptions.o: config.h
+dioptions.o: di.h disystem.h
+dioptions.o: diinternal.h

=== debian/changelog ===
di (5.0.12-1) unstable; urgency=medium

  * New upstream version 5.0.12

 -- Michael Ablassmeier <abi@debian.org>  Sat, 22 Feb 2025 21:03:53 +0100

di (5.0.11-1) unstable; urgency=medium

  * New upstream version 5.0.11

 -- Michael Ablassmeier <abi@debian.org>  Sat, 22 Feb 2025 20:49:24 +0100

di (5.0.7-1) unstable; urgency=medium

  * New upstream version 5.0.7

 -- Michael Ablassmeier <abi@debian.org>  Wed, 12 Feb 2025 19:36:07 +0100

## di 5.0.14

=== CMakeLists.txt ===
--- 
+++ 
@@ -98,15 +98,19 @@
 macro (checkAddCompileFlag flag)
   # cmake caches every damned variable...
   # need a different variable for every test.
-  check_c_compiler_flag (${flag} cfchk${flag})
-  if (cfchk${flag})
+  string (REPLACE "-" "_" tflag ${flag})
+  string (REPLACE "=" "_" tflag ${tflag})
+  check_c_compiler_flag (${flag} cfchk${tflag})
+  if (cfchk${tflag})
     add_compile_options (${flag})
   endif()
 endmacro()
 
 macro (checkAddLinkFlag flag)
-  check_linker_flag ("C" ${flag} lfchk${flag})
-  if (lfchk${flag})
+  string (REPLACE "-" "_" tflag ${flag})
+  string (REPLACE "=" "_" tflag ${tflag})
+  check_linker_flag ("C" ${flag} lfchk${tflag})
+  if (lfchk${tflag})
     add_link_options (${flag})
   endif()
 endmacro()
@@ -293,7 +297,9 @@
 )
 
 set (CMAKE_REQUIRED_INCLUDES ${required_includes})
-add_compile_options (-DWIN32_LEAN_AND_MEAN=1)
+if (WIN32)
+  add_compile_options (-DWIN32_LEAN_AND_MEAN=1)
+endif()
 
 #### configuration
 
@@ -414,13 +420,3 @@
     )
   check_prototype_definition (setmntent
     "FILE * setmntent (const char * a, const char * b)"
-    "NULL"
-    "stdio.h;stddef.h;${hdr}"
-    _args_setmntent_2
-    )
-  if (_args_setmntent_1)
-    set (_args_setmntent 1)
-  endif()
-  if (_args_setmntent_2)
-    set (_args_setmntent 2)
-  endif()

=== debian/changelog ===
di (5.0.14-1) unstable; urgency=medium

  * New upstream version 5.0.14 (Closes: #1099509)

 -- Michael Ablassmeier <abi@debian.org>  Tue, 04 Mar 2025 18:44:26 +0100

di (5.0.13-1) unstable; urgency=medium

  * New upstream version 5.0.13

 -- Michael Ablassmeier <abi@debian.org>  Sat, 01 Mar 2025 22:01:00 +0100

## di 6.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -58,7 +58,6 @@
 
 SET (CMAKE_SKIP_BUILD_RPATH FALSE)
 SET (CMAKE_BUILD_WITH_INSTALL_RPATH TRUE)
-
 if (DEFINED ENV{CMAKE_SKIP_RPATH} AND NOT ENV{CMAKE_SKIP_RPATH} STREQUAL "")
   set (CMAKE_SKIP_RPATH "$ENV{CMAKE_SKIP_RPATH}")
 endif()
@@ -96,8 +95,6 @@
 #### compile options
 
 macro (checkAddCompileFlag flag)
-  # cmake caches every damned variable...
-  # need a different variable for every test.
   string (REPLACE "-" "_" tflag ${flag})
   string (REPLACE "=" "_" tflag ${tflag})
   check_c_compiler_flag (${flag} cfchk${tflag})
@@ -420,3 +417,8 @@
     )
   check_prototype_definition (setmntent
     "FILE * setmntent (const char * a, const char * b)"
+    "NULL"
+    "stdio.h;stddef.h;${hdr}"
+    _args_setmntent_2
+    )
+  if (_args_setmntent_1)

=== Makefile ===
--- 
+++ 
@@ -143,6 +143,10 @@
 tar:
 	./utils/mktar.sh
 
+.PHONY: betatar
+betatar:
+	./utils/mktar.sh beta
+
 ###
 # cmake
 
@@ -159,7 +163,7 @@
 #   (passing -j w/o arguments, and *BSD complains)
 .PHONY: cmake-all
 cmake-all:
-	@case $$(uname -s) in \
+	@case `uname -s` in \
 	  CYGWIN*) \
 	    COMP=$(CC) \
 	    $(MAKE) -e cmake-unix; \
@@ -184,7 +188,7 @@
 
 .PHONY: cmakeclang
 cmakeclang:
-	case $$(uname -s) in \
+	case `uname -s` in \
 	  *BSD*) \
 	    COMP=$(CC) \
 	    $(MAKE) -e cmake-unix; \
@@ -309,19 +313,16 @@
 mkc-install-po:
 	-./utils/instpo.sh "`pwd`/po" $(INST_LOCALEDIR) "`pwd`/tmp"
 
+# -lintl and -liconv are removed, as those libraries are only needed
+# for the main di program, not to link with the library.
 .PHONY: mkc-install-pc
 mkc-install-pc: $(MKC_REQLIB)
 	test -d $(INST_PKGCDIR) || mkdir -p $(INST_PKGCDIR)
-	@dilibs="$${LDFLAGS_LIBS_APPLICATION} `cat $(MKC_REQLIB)`" ; \
-	dilibs="`echo $${dilibs} | \
-	    sed -e 's,-lintl,,g' \
-	    -e 's,-liconv,,g'`" ; \
 	cat di.pc.in | \
 	  sed -e 's,@CMAKE_INSTALL_PREFIX@,$(PREFIX),g' \
 	      -e 's,@CMAKE_INSTALL_FULL_INCLUDEDIR@,$(INCDIR),g' \
 	      -e 's,@CMAKE_INSTALL_FULL_LIBDIR@,$(LIBDIR),g' \
 	      -e 's,@DI_VERSION@,$(DI_VERSION),g' \
-	      -e "s~@DI_REQUIRED_LIBS@~$${dilibs}~" \
 	  > $(INST_PKGCDIR)/di.pc
 
 .PHONY: mkc-install-di
@@ -339,48 +340,12 @@
 .PHONY: mkc-install-libdi
 mkc-install-libdi:
 	test -d $(INST_LIBDIR) || mkdir -p $(INST_LIBDIR)
-	@sym=T ; \
-	instdest=$(INST_LIBDIR) ; \
-	case `uname -s` in \
-	  Darwin) \
-	    libnm=libdi.$(DI_LIBVERSION)$(SHLIB_EXT) ; \
-	    libnmso=libdi.$(DI_SOVERSION)$(SHLIB_EXT) ; \
-	    ;; \
-	  CYGWIN*|MSYS*|MINGW*) \
-	    instdest=$(INST_BINDIR) ; \
-	    libnm=libdi$(SHLIB_EXT) ; \
-	    sym=F ; \
-	    ;; \
-	  OpenBSD) \
-	    libnm=libdi$(SHLIB_EXT).$(DI_LIBVERSION) ; \
-	    libnmso=libdi$(SHLIB_EXT).$(DI_SOVERSION) ; \
-	    sym=O ; \
-	    ;; \
-	  *) \
-	    libnm=libdi$(SHLIB_EXT).$(DI_LIBVERSION) ; \
-	    libnmso=libdi$(SHLIB_EXT).$(DI_SOVERSION) ; \
-	    ;; \
-	esac ; \
-	cp -f libdi$(SHLIB_EXT) $${instdest}/$${libnm} ; \
-	if [ $$sym = T -o $$sym = O ]; then \
-	  ( \
-	    cd $(INST_LIBDIR) ; \
-	    ln -sf $${libnm} $${libnmso} ; \
-	  ) ; \
-	fi ; \
-	if [ $$sym = T ]; then \
-	  ( \
-	    cd $(INST_LIBDIR) ; \
-	    ln -sf $${libnmso} libdi$(SHLIB_EXT) ; \
-	  ) ; \
-	fi
-
+	./utils/instlibdi.sh "$(INST_LIBDIR)" "$(INST_BINDIR)" $(DI_LIBVERSION) $(DI_SOVERSION)
+
+# incorrect for netbsd
 .PHONY: mkc-install-man
 mkc-install-man:
-	-test -d $(INST_MANDIR)/man1 || mkdir -p $(INST_MANDIR)/man1
-	cp -f man/di.1 $(INST_MANDIR)/man1/$(MAN_TARGET)
-	-test -d $(INST_MANDIR)/man3 || mkdir -p $(INST_MANDIR)/man3
-	cp -f man/libdi.3 $(INST_MANDIR)/man3/$(MAN_TARGET)
+	./utils/instman.sh "$(PREFIX)" "$(MANDIR)"
 
 ###
 # mkc environment
@@ -519,3 +484,18 @@
 dioptions.o: config.h
 dioptions.o: di.h disystem.h
 dioptions.o: diinternal.h
+dioptions.o: dimath.h dioptions.h getoptn.h
+dioptions.o: distrutils.h
+diquota.o: config.h
+diquota.o: di.h
+diquota.o: disystem.h dimath.h
+diquota.o: diquota.h diinternal.h dioptions.h
+diquota.o: getoptn.h distrutils.h
+distrutils.o: config.h
+distrutils.o: distrutils.h
+dizone.o: config.h
+dizone.o: di.h dizone.h disystem.h
+dizone.o: dioptions.h getoptn.h distrutils.h
+getoptn.o: config.h
+getoptn.o: disystem.h
+getoptn.o: distrutils.h getoptn.h

=== debian/changelog ===
di (6.0.0-1) unstable; urgency=medium

  * New upstream version 6.0.0
  * Rename libdi5 to libdi6 to match new library version.
  * Move man page for libdi to -dev package, add conflict entry to
    debian/control.

 -- Michael Ablassmeier <abi@debian.org>  Mon, 10 Mar 2025 20:12:23 +0100

=== debian/control ===
--- 
+++ 
@@ -27,13 +27,14 @@
 
 Package: libdi-dev
 Architecture: any
-Depends: libdi5 (= ${binary:Version}), ${misc:Depends}
+Depends: libdi6 (= ${binary:Version}), ${misc:Depends}
 Section: libdevel
+Conflicts: libdi5
 Description: Header files for libdi
  Development files for libdi, a shared library that can be used to get disk
  space or percentages.
 
-Package: libdi5
+Package: libdi6
 Architecture: any
 Multi-Arch: same
 Pre-Depends: ${misc:Pre-Depends}

=== debian/watch ===
version=4
https://sf.net/diskinfo-di/ di-@ANY_VERSION@@ARCHIVE_EXT@
